# 2N low storage methods
function initialize!(integrator, cache::LowStorageRK2NConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::LowStorageRK2NConstantCache,
        repeat_step = false)
    @unpack t, dt, u, f, p = integrator
    @unpack A2end, B1, B2end, c2end = cache

    # u1
    tmp = dt * integrator.fsalfirst
    u = u + B1 * tmp

    # other stages
    for i in eachindex(A2end)
        k = f(u, p, t + c2end[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        tmp = A2end[i] * tmp + dt * k
        u = u + B2end[i] * tmp
    end

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.fsalfirst = f(u, p, t + dt) # For interpolation, then FSAL'd
    integrator.u = u
end

get_fsalfirstlast(cache::LowStorageRK2NCache, u) = (nothing, nothing)

function initialize!(integrator, cache::LowStorageRK2NCache)
    @unpack k, tmp, williamson_condition = cache
    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = k
    integrator.f(k, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::LowStorageRK2NCache, repeat_step = false)
    @unpack t, dt, u, f, p = integrator
    @unpack k, tmp, williamson_condition, stage_limiter!, step_limiter!, thread = cache
    @unpack A2end, B1, B2end, c2end = cache.tab

    # u1
    f(k, u, p, t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    @.. broadcast=false thread=thread tmp=dt * k
    @.. broadcast=false thread=thread u=u + B1 * tmp
    # other stages
    for i in eachindex(A2end)
        if williamson_condition
            f(ArrayFuse(tmp, u, (A2end[i], dt, B2end[i])), u, p, t + c2end[i] * dt)
        else
            @.. broadcast=false thread=thread tmp=A2end[i] * tmp
            stage_limiter!(u, integrator, p, t + c2end[i] * dt)
            f(k, u, p, t + c2end[i] * dt)
            @.. broadcast=false thread=thread tmp=tmp + dt * k
            @.. broadcast=false thread=thread u=u + B2end[i] * tmp
        end
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)
end

# 2C low storage methods
function initialize!(integrator, cache::LowStorageRK2CConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::LowStorageRK2CConstantCache,
        repeat_step = false)
    @unpack t, dt, u, f, p = integrator
    @unpack A2end, B1, B2end, c2end = cache

    # u1
    k = integrator.fsalfirst = f(u, p, t)
    integrator.k[1] = integrator.fsalfirst
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    u = u + B1 * dt * k

    # other stages
    for i in eachindex(A2end)
        tmp = u + A2end[i] * dt * k
        k = f(tmp, p, t + c2end[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        u = u + B2end[i] * dt * k
    end

    integrator.u = u
end

function initialize!(integrator, cache::LowStorageRK2CCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::LowStorageRK2CCache, repeat_step = false)
    @unpack t, dt, u, f, p = integrator
    @unpack k, fsalfirst, tmp, stage_limiter!, step_limiter!, thread = cache
    @unpack A2end, B1, B2end, c2end = cache.tab

    # u1
    @.. broadcast=false thread=thread k=integrator.fsalfirst
    @.. broadcast=false thread=thread u=u + B1 * dt * k

    # other stages
    for i in eachindex(A2end)
        @.. broadcast=false thread=thread tmp=u + A2end[i] * dt * k
        f(k, tmp, p, t + c2end[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast=false thread=thread u=u + B2end[i] * dt * k
    end
    step_limiter!(u, integrator, p, t + dt)
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

# 3S low storage methods
function initialize!(integrator, cache::LowStorageRK3SConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::LowStorageRK3SConstantCache,
        repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack γ12end, γ22end, γ32end, δ2end, β1, β2end, c2end = cache

    # u1
    tmp = u
    u = tmp + β1 * dt * integrator.fsalfirst

    # other stages
    for i in eachindex(γ12end)
        k = f(u, p, t + c2end[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        tmp = tmp + δ2end[i] * u
        u = γ12end[i] * u + γ22end[i] * tmp + γ32end[i] * uprev + β2end[i] * dt * k
    end

    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.u = u
end

function initialize!(integrator, cache::LowStorageRK3SCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::LowStorageRK3SCache, repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack k, fsalfirst, tmp, stage_limiter!, step_limiter!, thread = cache
    @unpack γ12end, γ22end, γ32end, δ2end, β1, β2end, c2end = cache.tab

    # u1
    @.. broadcast=false thread=thread tmp=u
    @.. broadcast=false thread=thread u=tmp + β1 * dt * integrator.fsalfirst

    # other stages
    for i in eachindex(γ12end)
        f(k, u, p, t + c2end[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast=false thread=thread tmp=tmp + δ2end[i] * u
        @.. broadcast=false thread=thread u=γ12end[i] * u + γ22end[i] * tmp +
                                            γ32end[i] * uprev +
                                            β2end[i] * dt * k
    end

    step_limiter!(u, integrator, p, t + dt)
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

# 3S+ low storage methods: 3S methods adding another memory location for the embedded method (non-FSAL version)
function initialize!(integrator, cache::LowStorageRK3SpConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::LowStorageRK3SpConstantCache,
        repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack γ12end, γ22end, γ32end, δ2end, β1, β2end, c2end, bhat1, bhat2end = cache

    # u1
    integrator.fsalfirst = f(uprev, p, t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    tmp = uprev
    u = tmp + β1 * dt * integrator.fsalfirst
    if integrator.opts.adaptive
        utilde = bhat1 * dt * integrator.fsalfirst
    end

    # other stages
    for i in eachindex(γ12end)
        k = f(u, p, t + c2end[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        tmp = tmp + δ2end[i] * u
        u = γ12end[i] * u + γ22end[i] * tmp + γ32end[i] * uprev + β2end[i] * dt * k
        if integrator.opts.adaptive
            utilde = utilde + bhat2end[i] * dt * k
        end
    end

    if integrator.opts.adaptive
        atmp = calculate_residuals(utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    integrator.u = u
end

function initialize!(integrator, cache::LowStorageRK3SpCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::LowStorageRK3SpCache, repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack k, tmp, utilde, atmp, stage_limiter!, step_limiter!, thread = cache
    @unpack γ12end, γ22end, γ32end, δ2end, β1, β2end, c2end, bhat1, bhat2end = cache.tab

    # u1
    f(integrator.fsalfirst, uprev, p, t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    @.. broadcast=false thread=thread tmp=uprev
    @.. broadcast=false thread=thread u=tmp + β1 * dt * integrator.fsalfirst
    if integrator.opts.adaptive
        @.. broadcast=false thread=thread utilde=bhat1 * dt * integrator.fsalfirst
    end

    # other stages
    for i in eachindex(γ12end)
        stage_limiter!(u, integrator, p, t + c2end[i] * dt)
        f(k, u, p, t + c2end[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast=false thread=thread tmp=tmp + δ2end[i] * u
        @.. broadcast=false thread=thread u=γ12end[i] * u + γ22end[i] * tmp +
                                            γ32end[i] * uprev + β2end[i] * dt * k
        if integrator.opts.adaptive
            @.. broadcast=false thread=thread utilde=utilde + bhat2end[i] * dt * k
        end
    end

    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)

    if integrator.opts.adaptive
        calculate_residuals!(atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

# 3S+ FSAL low storage methods: 3S methods adding another memory location for the embedded method (FSAL version)
function initialize!(integrator, cache::LowStorageRK3SpFSALConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::LowStorageRK3SpFSALConstantCache,
        repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack γ12end, γ22end, γ32end, δ2end, β1, β2end, c2end, bhat1, bhat2end, bhatfsal = cache

    # u1
    tmp = uprev
    u = tmp + β1 * dt * integrator.fsalfirst
    if integrator.opts.adaptive
        utilde = bhat1 * dt * integrator.fsalfirst
    end

    # other stages
    for i in eachindex(γ12end)
        k = f(u, p, t + c2end[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        tmp = tmp + δ2end[i] * u
        u = γ12end[i] * u + γ22end[i] * tmp + γ32end[i] * uprev + β2end[i] * dt * k
        if integrator.opts.adaptive
            utilde = utilde + bhat2end[i] * dt * k
        end
    end

    # FSAL
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    if integrator.opts.adaptive
        utilde = utilde + bhatfsal * dt * integrator.fsallast
        atmp = calculate_residuals(utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

function initialize!(integrator, cache::LowStorageRK3SpFSALCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::LowStorageRK3SpFSALCache,
        repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack k, tmp, utilde, atmp, stage_limiter!, step_limiter!, thread = cache
    @unpack γ12end, γ22end, γ32end, δ2end, β1, β2end, c2end, bhat1, bhat2end, bhatfsal = cache.tab

    # u1
    @.. broadcast=false thread=thread tmp=uprev
    @.. broadcast=false thread=thread u=tmp + β1 * dt * integrator.fsalfirst
    if integrator.opts.adaptive
        @.. broadcast=false thread=thread utilde=bhat1 * dt * integrator.fsalfirst
    end

    # other stages
    for i in eachindex(γ12end)
        stage_limiter!(u, integrator, p, t + c2end[i] * dt)
        f(k, u, p, t + c2end[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast=false thread=thread tmp=tmp + δ2end[i] * u
        @.. broadcast=false thread=thread u=γ12end[i] * u + γ22end[i] * tmp +
                                            γ32end[i] * uprev + β2end[i] * dt * k
        if integrator.opts.adaptive
            @.. broadcast=false thread=thread utilde=utilde + bhat2end[i] * dt * k
        end
    end

    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)

    # FSAL
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    if integrator.opts.adaptive
        @.. broadcast=false thread=thread utilde=utilde + bhatfsal * dt * k
        calculate_residuals!(atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
end

# 2R+ low storage methods
function initialize!(integrator, cache::LowStorageRK2RPConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::LowStorageRK2RPConstantCache,
        repeat_step = false)
    @unpack t, dt, u, uprev, f, fsalfirst, p = integrator
    @unpack Aᵢ, Bₗ, B̂ₗ, Bᵢ, B̂ᵢ, Cᵢ = cache

    k = fsalfirst
    integrator.opts.adaptive && (tmp = zero(uprev))

    #stages 1 to s-1
    for i in eachindex(Aᵢ)
        integrator.opts.adaptive && (tmp = tmp + (Bᵢ[i] - B̂ᵢ[i]) * dt * k)
        gprev = u + Aᵢ[i] * dt * k
        u = u + Bᵢ[i] * dt * k
        k = f(gprev, p, t + Cᵢ[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    #last stage
    integrator.opts.adaptive && (tmp = tmp + (Bₗ - B̂ₗ) * dt * k)
    u = u + Bₗ * dt * k

    #Error estimate
    if integrator.opts.adaptive
        atmp = calculate_residuals(tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    integrator.k[1] = integrator.fsalfirst
    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.u = u
end

function initialize!(integrator, cache::LowStorageRK2RPCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::LowStorageRK2RPCache, repeat_step = false)
    @unpack t, dt, u, uprev, f, fsalfirst, p = integrator
    @unpack k, gprev, tmp, atmp, stage_limiter!, step_limiter!, thread = cache
    @unpack Aᵢ, Bₗ, B̂ₗ, Bᵢ, B̂ᵢ, Cᵢ = cache.tab

    @.. broadcast=false thread=thread k=fsalfirst
    integrator.opts.adaptive && (@.. broadcast=false tmp=zero(uprev))

    #stages 1 to s-1
    for i in eachindex(Aᵢ)
        integrator.opts.adaptive &&
            (@.. broadcast=false thread=thread tmp=tmp + (Bᵢ[i] - B̂ᵢ[i]) * dt * k)
        @.. broadcast=false thread=thread gprev=u + Aᵢ[i] * dt * k
        @.. broadcast=false thread=thread u=u + Bᵢ[i] * dt * k
        f(k, gprev, p, t + Cᵢ[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    #last stage
    integrator.opts.adaptive &&
        (@.. broadcast=false thread=thread tmp=tmp + (Bₗ - B̂ₗ) * dt * k)
    @.. broadcast=false thread=thread u=u + Bₗ * dt * k

    #Error estimate
    if integrator.opts.adaptive
        calculate_residuals!(atmp, tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    step_limiter!(u, integrator, p, t + dt)
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

# 3R+ low storage methods
function initialize!(integrator, cache::LowStorageRK3RPConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::LowStorageRK3RPConstantCache,
        repeat_step = false)
    @unpack t, dt, u, uprev, f, fsalfirst, p = integrator
    @unpack Aᵢ₁, Aᵢ₂, Bₗ, B̂ₗ, Bᵢ, B̂ᵢ, Cᵢ = cache

    fᵢ₋₂ = zero(fsalfirst)
    k = fsalfirst
    uᵢ₋₁ = uprev
    uᵢ₋₂ = uprev
    integrator.opts.adaptive && (tmp = zero(uprev))

    #stages 1 to s-1
    for i in eachindex(Aᵢ₁)
        integrator.opts.adaptive && (tmp = tmp + (Bᵢ[i] - B̂ᵢ[i]) * dt * k)
        gprev = uᵢ₋₂ + (Aᵢ₁[i] * k + Aᵢ₂[i] * fᵢ₋₂) * dt
        u = u + Bᵢ[i] * dt * k
        fᵢ₋₂ = k
        uᵢ₋₂ = uᵢ₋₁
        uᵢ₋₁ = u
        k = f(gprev, p, t + Cᵢ[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    #last stage
    integrator.opts.adaptive && (tmp = tmp + (Bₗ - B̂ₗ) * dt * k)
    u = u + Bₗ * dt * k

    #Error estimate
    if integrator.opts.adaptive
        atmp = calculate_residuals(tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    integrator.k[1] = integrator.fsalfirst
    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.u = u
end

function initialize!(integrator, cache::LowStorageRK3RPCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::LowStorageRK3RPCache, repeat_step = false)
    @unpack t, dt, u, uprev, f, fsalfirst, p = integrator
    @unpack k, uᵢ₋₁, uᵢ₋₂, gprev, fᵢ₋₂, tmp, atmp, stage_limiter!, step_limiter!, thread = cache
    @unpack Aᵢ₁, Aᵢ₂, Bₗ, B̂ₗ, Bᵢ, B̂ᵢ, Cᵢ = cache.tab

    @.. broadcast=false thread=thread fᵢ₋₂=zero(fsalfirst)
    @.. broadcast=false thread=thread k=fsalfirst
    integrator.opts.adaptive && (@.. broadcast=false thread=thread tmp=zero(uprev))
    @.. broadcast=false thread=thread uᵢ₋₁=uprev
    @.. broadcast=false thread=thread uᵢ₋₂=uprev

    #stages 1 to s-1
    for i in eachindex(Aᵢ₁)
        integrator.opts.adaptive &&
            (@.. broadcast=false thread=thread tmp=tmp + (Bᵢ[i] - B̂ᵢ[i]) * dt * k)
        @.. broadcast=false thread=thread gprev=uᵢ₋₂ + (Aᵢ₁[i] * k + Aᵢ₂[i] * fᵢ₋₂) * dt
        @.. broadcast=false thread=thread u=u + Bᵢ[i] * dt * k
        @.. broadcast=false thread=thread fᵢ₋₂=k
        @.. broadcast=false thread=thread uᵢ₋₂=uᵢ₋₁
        @.. broadcast=false thread=thread uᵢ₋₁=u
        f(k, gprev, p, t + Cᵢ[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    #last stage
    integrator.opts.adaptive &&
        (@.. broadcast=false thread=thread tmp=tmp + (Bₗ - B̂ₗ) * dt * k)
    @.. broadcast=false thread=thread u=u + Bₗ * dt * k

    step_limiter!(u, integrator, p, t + dt)

    #Error estimate
    if integrator.opts.adaptive
        calculate_residuals!(atmp, tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

# 4R+ low storage methods
function initialize!(integrator, cache::LowStorageRK4RPConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::LowStorageRK4RPConstantCache,
        repeat_step = false)
    @unpack t, dt, u, uprev, f, fsalfirst, p = integrator
    @unpack Aᵢ₁, Aᵢ₂, Aᵢ₃, Bₗ, B̂ₗ, Bᵢ, B̂ᵢ, Cᵢ = cache

    fᵢ₋₂ = zero(fsalfirst)
    fᵢ₋₃ = zero(fsalfirst)
    k = fsalfirst
    uᵢ₋₁ = uprev
    uᵢ₋₂ = uprev
    uᵢ₋₃ = uprev
    integrator.opts.adaptive && (tmp = zero(uprev))

    #stages 1 to s-1
    for i in eachindex(Aᵢ₁)
        integrator.opts.adaptive && (tmp = tmp + (Bᵢ[i] - B̂ᵢ[i]) * dt * k)
        gprev = uᵢ₋₃ + (Aᵢ₁[i] * k + Aᵢ₂[i] * fᵢ₋₂ + Aᵢ₃[i] * fᵢ₋₃) * dt
        u = u + Bᵢ[i] * dt * k
        fᵢ₋₃ = fᵢ₋₂
        fᵢ₋₂ = k
        uᵢ₋₃ = uᵢ₋₂
        uᵢ₋₂ = uᵢ₋₁
        uᵢ₋₁ = u
        k = f(gprev, p, t + Cᵢ[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    #last stage
    integrator.opts.adaptive && (tmp = tmp + (Bₗ - B̂ₗ) * dt * k)
    u = u + Bₗ * dt * k

    #Error estimate
    if integrator.opts.adaptive
        atmp = calculate_residuals(tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    integrator.k[1] = integrator.fsalfirst
    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.u = u
end

function initialize!(integrator, cache::LowStorageRK4RPCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::LowStorageRK4RPCache, repeat_step = false)
    @unpack t, dt, u, uprev, f, fsalfirst, p = integrator
    @unpack k, uᵢ₋₁, uᵢ₋₂, uᵢ₋₃, gprev, fᵢ₋₂, fᵢ₋₃, tmp, atmp, stage_limiter!, step_limiter!, thread = cache
    @unpack Aᵢ₁, Aᵢ₂, Aᵢ₃, Bₗ, B̂ₗ, Bᵢ, B̂ᵢ, Cᵢ = cache.tab

    @.. broadcast=false thread=thread fᵢ₋₂=zero(fsalfirst)
    @.. broadcast=false thread=thread fᵢ₋₃=zero(fsalfirst)
    @.. broadcast=false thread=thread k=fsalfirst
    integrator.opts.adaptive && (@.. broadcast=false thread=thread tmp=zero(uprev))
    @.. broadcast=false thread=thread uᵢ₋₁=uprev
    @.. broadcast=false thread=thread uᵢ₋₂=uprev
    @.. broadcast=false thread=thread uᵢ₋₃=uprev

    #stages 1 to s-1
    for i in eachindex(Aᵢ₁)
        integrator.opts.adaptive &&
            (@.. broadcast=false thread=thread tmp=tmp + (Bᵢ[i] - B̂ᵢ[i]) * dt * k)
        @.. broadcast=false thread=thread gprev=uᵢ₋₃ +
                                                (Aᵢ₁[i] * k + Aᵢ₂[i] * fᵢ₋₂ +
                                                 Aᵢ₃[i] * fᵢ₋₃) *
                                                dt
        @.. broadcast=false thread=thread u=u + Bᵢ[i] * dt * k
        @.. broadcast=false thread=thread fᵢ₋₃=fᵢ₋₂
        @.. broadcast=false thread=thread fᵢ₋₂=k
        @.. broadcast=false thread=thread uᵢ₋₃=uᵢ₋₂
        @.. broadcast=false thread=thread uᵢ₋₂=uᵢ₋₁
        @.. broadcast=false thread=thread uᵢ₋₁=u
        f(k, gprev, p, t + Cᵢ[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    #last stage
    integrator.opts.adaptive &&
        (@.. broadcast=false thread=thread tmp=tmp + (Bₗ - B̂ₗ) * dt * k)
    @.. broadcast=false thread=thread u=u + Bₗ * dt * k

    step_limiter!(u, integrator, p, t + dt)

    #Error estimate
    if integrator.opts.adaptive
        calculate_residuals!(atmp, tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

# 5R+ low storage methods
function initialize!(integrator, cache::LowStorageRK5RPConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::LowStorageRK5RPConstantCache,
        repeat_step = false)
    @unpack t, dt, u, uprev, f, fsalfirst, p = integrator
    @unpack Aᵢ₁, Aᵢ₂, Aᵢ₃, Aᵢ₄, Bₗ, B̂ₗ, Bᵢ, B̂ᵢ, Cᵢ = cache

    fᵢ₋₂ = zero(fsalfirst)
    fᵢ₋₃ = zero(fsalfirst)
    fᵢ₋₄ = zero(fsalfirst)
    k = fsalfirst
    uᵢ₋₁ = uprev
    uᵢ₋₂ = uprev
    uᵢ₋₃ = uprev
    uᵢ₋₄ = uprev
    integrator.opts.adaptive && (tmp = zero(uprev))

    #stages 1 to s-1
    for i in eachindex(Aᵢ₁)
        integrator.opts.adaptive && (tmp = tmp + (Bᵢ[i] - B̂ᵢ[i]) * dt * k)
        gprev = uᵢ₋₄ + (Aᵢ₁[i] * k + Aᵢ₂[i] * fᵢ₋₂ + Aᵢ₃[i] * fᵢ₋₃ + Aᵢ₄[i] * fᵢ₋₄) * dt
        u = u + Bᵢ[i] * dt * k
        fᵢ₋₄ = fᵢ₋₃
        fᵢ₋₃ = fᵢ₋₂
        fᵢ₋₂ = k
        uᵢ₋₄ = uᵢ₋₃
        uᵢ₋₃ = uᵢ₋₂
        uᵢ₋₂ = uᵢ₋₁
        uᵢ₋₁ = u
        k = f(gprev, p, t + Cᵢ[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    #last stage
    integrator.opts.adaptive && (tmp = tmp + (Bₗ - B̂ₗ) * dt * k)
    u = u + Bₗ * dt * k

    #Error estimate
    if integrator.opts.adaptive
        atmp = calculate_residuals(tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    integrator.k[1] = integrator.fsalfirst
    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.u = u
end

function initialize!(integrator, cache::LowStorageRK5RPCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::LowStorageRK5RPCache, repeat_step = false)
    @unpack t, dt, u, uprev, f, fsalfirst, p = integrator
    @unpack k, uᵢ₋₁, uᵢ₋₂, uᵢ₋₃, uᵢ₋₄, gprev, fᵢ₋₂, fᵢ₋₃, fᵢ₋₄, tmp, atmp, stage_limiter!, step_limiter!, thread = cache
    @unpack Aᵢ₁, Aᵢ₂, Aᵢ₃, Aᵢ₄, Bₗ, B̂ₗ, Bᵢ, B̂ᵢ, Cᵢ = cache.tab

    @.. broadcast=false thread=thread fᵢ₋₂=zero(fsalfirst)
    @.. broadcast=false thread=thread fᵢ₋₃=zero(fsalfirst)
    @.. broadcast=false thread=thread fᵢ₋₄=zero(fsalfirst)
    @.. broadcast=false thread=thread k=fsalfirst
    integrator.opts.adaptive && (@.. broadcast=false thread=thread tmp=zero(uprev))
    @.. broadcast=false thread=thread uᵢ₋₁=uprev
    @.. broadcast=false thread=thread uᵢ₋₂=uprev
    @.. broadcast=false thread=thread uᵢ₋₃=uprev
    @.. broadcast=false thread=thread uᵢ₋₄=uprev

    #stages 1 to s-1
    for i in eachindex(Aᵢ₁)
        integrator.opts.adaptive &&
            (@.. broadcast=false thread=thread tmp=tmp + (Bᵢ[i] - B̂ᵢ[i]) * dt * k)
        @.. broadcast=false thread=thread gprev=uᵢ₋₄ +
                                                (Aᵢ₁[i] * k + Aᵢ₂[i] * fᵢ₋₂ +
                                                 Aᵢ₃[i] * fᵢ₋₃ +
                                                 Aᵢ₄[i] * fᵢ₋₄) * dt
        @.. broadcast=false thread=thread u=u + Bᵢ[i] * dt * k
        @.. broadcast=false thread=thread fᵢ₋₄=fᵢ₋₃
        @.. broadcast=false thread=thread fᵢ₋₃=fᵢ₋₂
        @.. broadcast=false thread=thread fᵢ₋₂=k
        @.. broadcast=false thread=thread uᵢ₋₄=uᵢ₋₃
        @.. broadcast=false thread=thread uᵢ₋₃=uᵢ₋₂
        @.. broadcast=false thread=thread uᵢ₋₂=uᵢ₋₁
        @.. broadcast=false thread=thread uᵢ₋₁=u
        f(k, gprev, p, t + Cᵢ[i] * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end

    #last stage
    integrator.opts.adaptive &&
        (@.. broadcast=false thread=thread tmp=tmp + (Bₗ - B̂ₗ) * dt * k)
    @.. broadcast=false thread=thread u=u + Bₗ * dt * k

    step_limiter!(u, integrator, p, t + dt)

    #Error estimate
    if integrator.opts.adaptive
        calculate_residuals!(atmp, tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread)
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end

    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

function initialize!(integrator, cache::RK46NLCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 1
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::RK46NLCache, repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack k, fsalfirst, tmp, stage_limiter!, step_limiter!, thread = cache
    @unpack α2, α3, α4, α5, α6, β1, β2, β3, β4, β5, β6, c2, c3, c4, c5, c6 = cache.tab

    # u1
    @.. broadcast=false thread=thread tmp=dt * fsalfirst
    @.. broadcast=false thread=thread u=uprev + β1 * tmp
    stage_limiter!(u, integrator, p, t + c2 * dt)
    # u2
    f(k, u, p, t + c2 * dt)
    @.. broadcast=false thread=thread tmp=α2 * tmp + dt * k
    @.. broadcast=false thread=thread u=u + β2 * tmp
    stage_limiter!(u, integrator, p, t + c3 * dt)
    # u3
    f(k, u, p, t + c3 * dt)
    @.. broadcast=false thread=thread tmp=α3 * tmp + dt * k
    @.. broadcast=false thread=thread u=u + β3 * tmp
    stage_limiter!(u, integrator, p, t + c4 * dt)
    # u4
    f(k, u, p, t + c4 * dt)
    @.. broadcast=false thread=thread tmp=α4 * tmp + dt * k
    @.. broadcast=false thread=thread u=u + β4 * tmp
    stage_limiter!(u, integrator, p, t + c5 * dt)
    # u5 = u
    f(k, u, p, t + c5 * dt)
    @.. broadcast=false thread=thread tmp=α5 * tmp + dt * k
    @.. broadcast=false thread=thread u=u + β5 * tmp
    stage_limiter!(u, integrator, p, t + c6 * dt)

    f(k, u, p, t + c6 * dt)
    @.. broadcast=false thread=thread tmp=α6 * tmp + dt * k
    @.. broadcast=false thread=thread u=u + β6 * tmp
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)

    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
end

function initialize!(integrator, cache::RK46NLConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 1
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
end

@muladd function perform_step!(integrator, cache::RK46NLConstantCache, repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack α2, α3, α4, α5, α6, β1, β2, β3, β4, β5, β6, c2, c3, c4, c5, c6 = cache

    # u1
    tmp = dt * integrator.fsalfirst
    u = uprev + β1 * tmp
    # u2
    tmp = α2 * tmp + dt * f(u, p, t + c2 * dt)
    u = u + β2 * tmp
    # u3
    tmp = α3 * tmp + dt * f(u, p, t + c3 * dt)
    u = u + β3 * tmp
    # u4
    tmp = α4 * tmp + dt * f(u, p, t + c4 * dt)
    u = u + β4 * tmp
    # u5 = u
    tmp = α5 * tmp + dt * f(u, p, t + c5 * dt)
    u = u + β5 * tmp
    # u6
    tmp = α6 * tmp + dt * f(u, p, t + c6 * dt)
    u = u + β6 * tmp

    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    integrator.k[1] = integrator.fsalfirst
    integrator.u = u
end

function initialize!(integrator, cache::SHLDDRK52ConstantCache)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::SHLDDRK52ConstantCache,
        repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack α2, α3, α4, α5, β1, β2, β3, β4, β5, c2, c3, c4, c5 = cache

    # u1
    tmp = dt * integrator.fsalfirst
    u = uprev + β1 * tmp
    # u2
    tmp = α2 * tmp + dt * f(u, p, t + c2 * dt)
    u = u + β2 * tmp
    # u3
    tmp = α3 * tmp + dt * f(u, p, t + c3 * dt)
    u = u + β3 * tmp
    # u4
    tmp = α4 * tmp + dt * f(u, p, t + c4 * dt)
    u = u + β4 * tmp
    # u5 = u
    tmp = α5 * tmp + dt * f(u, p, t + c5 * dt)
    u = u + β5 * tmp

    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.u = u
end

function initialize!(integrator, cache::SHLDDRK52Cache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::SHLDDRK52Cache, repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack k, fsalfirst, tmp, stage_limiter!, step_limiter!, thread = cache
    @unpack α2, α3, α4, α5, β1, β2, β3, β4, β5, c2, c3, c4, c5 = cache.tab

    # u1
    @.. thread=thread tmp=dt * fsalfirst
    @.. thread=thread u=uprev + β1 * tmp
    stage_limiter!(u, integrator, p, t + c2 * dt)
    # u2
    f(k, u, p, t + c2 * dt)
    @.. thread=thread tmp=α2 * tmp + dt * k
    @.. thread=thread u=u + β2 * tmp
    stage_limiter!(u, integrator, p, t + c3 * dt)
    # u3
    f(k, u, p, t + c3 * dt)
    @.. thread=thread tmp=α3 * tmp + dt * k
    @.. thread=thread u=u + β3 * tmp
    stage_limiter!(u, integrator, p, t + c4 * dt)
    # u4
    f(k, u, p, t + c4 * dt)
    @.. thread=thread tmp=α4 * tmp + dt * k
    @.. thread=thread u=u + β4 * tmp
    stage_limiter!(u, integrator, p, t + c5 * dt)
    # u5 = u
    f(k, u, p, t + c5 * dt)
    @.. thread=thread tmp=α5 * tmp + dt * k
    @.. thread=thread u=u + β5 * tmp
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)

    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
end

function initialize!(integrator, cache::SHLDDRK_2NConstantCache)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::SHLDDRK_2NConstantCache,
        repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack α21, α31, α41, α51, β11, β21, β31, β41, β51, c21, c31, c41, c51, α22, α32, α42, α52, α62, β12, β22, β32, β42, β52, β62, c22, c32, c42, c52, c62 = cache

    if integrator.u_modified
        cache.step = 1
    end
    # cnt = cache.step

    if cache.step % 2 == 1
        cache.step += 1
        # u1
        tmp = dt * integrator.fsalfirst
        u = uprev + β11 * tmp
        # u2
        tmp = α21 * tmp + dt * f(u, p, t + c21 * dt)
        u = u + β21 * tmp
        # u3
        tmp = α31 * tmp + dt * f(u, p, t + c31 * dt)
        u = u + β31 * tmp
        # u4
        tmp = α41 * tmp + dt * f(u, p, t + c41 * dt)
        u = u + β41 * tmp
        # u5 = u
        tmp = α51 * tmp + dt * f(u, p, t + c51 * dt)
        u = u + β51 * tmp
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    else
        cache.step += 1
        # u1
        tmp = dt * integrator.fsalfirst
        u = uprev + β12 * tmp
        # u2
        tmp = α22 * tmp + dt * f(u, p, t + c22 * dt)
        u = u + β22 * tmp
        # u3
        tmp = α32 * tmp + dt * f(u, p, t + c32 * dt)
        u = u + β32 * tmp
        # u4
        tmp = α42 * tmp + dt * f(u, p, t + c42 * dt)
        u = u + β42 * tmp
        # u5 = u
        tmp = α52 * tmp + dt * f(u, p, t + c52 * dt)
        u = u + β52 * tmp
        tmp = α62 * tmp + dt * f(u, p, t + c62 * dt)
        u = u + β62 * tmp
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    end

    integrator.fsallast = f(u, p, t + dt) # For interpolation, then FSAL'd
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.u = u
end

function initialize!(integrator, cache::SHLDDRK_2NCache)
    @unpack k, fsalfirst = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # FSAL for interpolation
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::SHLDDRK_2NCache, repeat_step = false)
    @unpack t, dt, uprev, u, f, p = integrator
    @unpack k, fsalfirst, tmp, stage_limiter!, step_limiter!, thread = cache
    @unpack α21, α31, α41, α51, β11, β21, β31, β41, β51, c21, c31, c41, c51, α22, α32, α42, α52, α62, β12, β22, β32, β42, β52, β62, c22, c32, c42, c52, c62 = cache.tab

    if integrator.u_modified
        cache.step = 1
    end

    if cache.step % 2 == 1
        # u1
        @.. thread=thread tmp=dt * fsalfirst
        @.. thread=thread u=uprev + β11 * tmp
        stage_limiter!(u, integrator, p, t + c21 * dt)
        # u2
        f(k, u, p, t + c21 * dt)
        @.. thread=thread tmp=α21 * tmp + dt * k
        @.. thread=thread u=u + β21 * tmp
        stage_limiter!(u, integrator, p, t + c31 * dt)
        # u3
        f(k, u, p, t + c31 * dt)
        @.. thread=thread tmp=α31 * tmp + dt * k
        @.. thread=thread u=u + β31 * tmp
        stage_limiter!(u, integrator, p, t + c41 * dt)
        # u4
        f(k, u, p, t + c41 * dt)
        @.. thread=thread tmp=α41 * tmp + dt * k
        @.. thread=thread u=u + β41 * tmp
        stage_limiter!(u, integrator, p, t + c51 * dt)
        # u5 = u
        f(k, u, p, t + c51 * dt)
        @.. thread=thread tmp=α51 * tmp + dt * k
        @.. thread=thread u=u + β51 * tmp
        stage_limiter!(u, integrator, p, t + dt)
        step_limiter!(u, integrator, p, t + dt)

        f(k, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    else
        # u1
        @.. thread=thread tmp=dt * fsalfirst
        @.. thread=thread u=uprev + β12 * tmp
        stage_limiter!(u, integrator, p, t + c22 * dt)
        # u2
        f(k, u, p, t + c22 * dt)
        @.. thread=thread tmp=α22 * tmp + dt * k
        @.. thread=thread u=u + β22 * tmp
        stage_limiter!(u, integrator, p, t + c32 * dt)
        # u3
        f(k, u, p, t + c32 * dt)
        @.. thread=thread tmp=α32 * tmp + dt * k
        @.. thread=thread u=u + β32 * tmp
        stage_limiter!(u, integrator, p, t + c42 * dt)
        # u4
        f(k, u, p, t + c42 * dt)
        @.. thread=thread tmp=α42 * tmp + dt * k
        @.. thread=thread u=u + β42 * tmp
        stage_limiter!(u, integrator, p, t + c52 * dt)
        # u5 = u
        f(k, u, p, t + c52 * dt)
        @.. thread=thread tmp=α52 * tmp + dt * k
        @.. thread=thread u=u + β52 * tmp
        stage_limiter!(u, integrator, p, t + c62 * dt)
        # u6 = u
        f(k, u, p, t + c62 * dt)
        @.. thread=thread tmp=α62 * tmp + dt * k
        @.. thread=thread u=u + β62 * tmp
        stage_limiter!(u, integrator, p, t + dt)
        step_limiter!(u, integrator, p, t + dt)

        f(k, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 6)
    end
end

@doc explicit_rk_docstring(
    "A second-order, five-stage method for wave propagation
equations. Fixed timestep only.", "ORK256",
    references = "Matteo Bernardini, Sergio Pirozzoli.
    A General Strategy for the Optimization of Runge-Kutta Schemes for Wave
    Propagation Phenomena.
    Journal of Computational Physics, 228(11), pp 4182-4199, 2009.
    doi: https://doi.org/10.1016/j.jcp.2009.02.032",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
Base.@kwdef struct ORK256{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    williamson_condition::Bool = true
end
# for backwards compatibility
function ORK256(stage_limiter!,
        step_limiter! = trivial_limiter!;
        williamson_condition = true)
    ORK256(stage_limiter!, step_limiter!, False(), williamson_condition)
end

@doc explicit_rk_docstring(
    "7-stage, third order low-storage low-dissipation, low-dispersion scheme for
discontinuous Galerkin space discretizations applied to wave propagation problems.
Optimized for PDE discretizations when maximum spatial step is small due to
geometric features of computational domain. Fixed timestep only.",
    "DGLDDRK73_C",
    references = "T. Toulorge, W. Desmet.
    Optimal Runge–Kutta Schemes for Discontinuous Galerkin Space Discretizations
    Applied to Wave Propagation Problems.
    Journal of Computational Physics, 231(4), pp 2067-2091, 2012.
    doi: https://doi.org/10.1016/j.jcp.2011.11.024",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
Base.@kwdef struct DGLDDRK73_C{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    williamson_condition::Bool = true
end
# for backwards compatibility
function DGLDDRK73_C(stage_limiter!, step_limiter! = trivial_limiter!;
        williamson_condition = true)
    DGLDDRK73_C(stage_limiter!,
        step_limiter!,
        False(),
        williamson_condition)
end

@doc explicit_rk_docstring(
    "A fourth-order, five-stage low-storage method of Carpenter and Kennedy
(free 3rd order Hermite interpolant). Fixed timestep only. Designed for
hyperbolic PDEs (stability properties).",
    "CarpenterKennedy2N54",
    references = "@article{carpenter1994fourth,
    title={Fourth-order 2N-storage Runge-Kutta schemes},
    author={Carpenter, Mark H and Kennedy, Christopher A},
    year={1994}
    }",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
Base.@kwdef struct CarpenterKennedy2N54{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    williamson_condition::Bool = true
end
# for backwards compatibility
function CarpenterKennedy2N54(stage_limiter!,
        step_limiter! = trivial_limiter!;
        williamson_condition = true)
    CarpenterKennedy2N54(stage_limiter!, step_limiter!, False(), williamson_condition)
end

@doc explicit_rk_docstring(
    "12-stage, fourth order low-storage method with optimized stability regions for
advection-dominated problems. Fixed timestep only.",
    "NDBLSRK124",
    references = "Jens Niegemann, Richard Diehl, Kurt Busch.
    Efficient Low-Storage Runge–Kutta Schemes with Optimized Stability Regions.
    Journal of Computational Physics, 231, pp 364-372, 2012.
    doi: https://doi.org/10.1016/j.jcp.2011.09.003",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
Base.@kwdef struct NDBLSRK124{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    williamson_condition::Bool = true
end
# for backwards compatibility
function NDBLSRK124(stage_limiter!, step_limiter! = trivial_limiter!;
        williamson_condition = true)
    NDBLSRK124(stage_limiter!,
        step_limiter!, False(),
        williamson_condition)
end

@doc explicit_rk_docstring(
    "14-stage, fourth order low-storage method with optimized stability regions for
advection-dominated problems. Fixed timestep only.",
    "NDBLSRK144",
    references = "Jens Niegemann, Richard Diehl, Kurt Busch.
    Efficient Low-Storage Runge–Kutta Schemes with Optimized Stability Regions.
    Journal of Computational Physics, 231, pp 364-372, 2012.
    doi: https://doi.org/10.1016/j.jcp.2011.09.003",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
Base.@kwdef struct NDBLSRK144{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    williamson_condition::Bool = true
end
# for backwards compatibility
function NDBLSRK144(stage_limiter!, step_limiter! = trivial_limiter!;
        williamson_condition = true)
    NDBLSRK144{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!, False(),
        williamson_condition)
end

@doc explicit_rk_docstring("Low-Storage Method
6-stage, fourth order low-storage, low-dissipation, low-dispersion scheme.
Fixed timestep only.", "CFRLDDRK64",
    references = "M. Calvo, J. M. Franco, L. Randez. A New Minimum Storage Runge–Kutta Scheme
    for Computational Acoustics. Journal of Computational Physics, 201, pp 1-12, 2004.
    doi: https://doi.org/10.1016/j.jcp.2004.05.012")
Base.@kwdef struct CFRLDDRK64{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CFRLDDRK64(stage_limiter!, step_limiter! = trivial_limiter!)
    CFRLDDRK64(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
7-stage, fourth order low-storage low-dissipation, low-dispersion scheme with maximal accuracy and stability limit along the imaginary axes.
Fixed timestep only.",
    "TSLDDRK74",
    references = "Kostas Tselios, T. E. Simos. Optimized Runge–Kutta Methods with Minimal Dispersion and Dissipation
    for Problems arising from Computational Acoustics. Physics Letters A, 393(1-2), pp 38-47, 2007.
    doi: https://doi.org/10.1016/j.physleta.2006.10.072")
Base.@kwdef struct TSLDDRK74{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function TSLDDRK74(stage_limiter!, step_limiter! = trivial_limiter!)
    TSLDDRK74(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "8-stage, fourth order low-storage low-dissipation, low-dispersion scheme for
discontinuous Galerkin space discretizations applied to wave propagation problems.
Optimized for PDE discretizations when maximum spatial step is small due to
geometric features of computational domain. Fixed timestep only.",
    "DGLDDRK84_C",
    references = "T. Toulorge, W. Desmet.
    Optimal Runge–Kutta Schemes for Discontinuous Galerkin Space Discretizations
    Applied to Wave Propagation Problems.
    Journal of Computational Physics, 231(4), pp 2067-2091, 2012.
    doi: https://doi.org/10.1016/j.jcp.2011.11.024",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
Base.@kwdef struct DGLDDRK84_C{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    williamson_condition::Bool = true
end
# for backwards compatibility
function DGLDDRK84_C(stage_limiter!, step_limiter! = trivial_limiter!;
        williamson_condition = true)
    DGLDDRK84_C(stage_limiter!,
        step_limiter!,
        False(),
        williamson_condition)
end

@doc explicit_rk_docstring(
    "8-stage, fourth order low-storage low-dissipation, low-dispersion scheme for
discontinuous Galerkin space discretizations applied to wave propagation problems.
Optimized for PDE discretizations when the maximum spatial step size is not
constrained. Fixed timestep only.",
    "DGLDDRK84_F",
    references = "T. Toulorge, W. Desmet.
    Optimal Runge–Kutta Schemes for Discontinuous Galerkin Space Discretizations
    Applied to Wave Propagation Problems.
    Journal of Computational Physics, 231(4), pp 2067-2091, 2012.
    doi: https://doi.org/10.1016/j.jcp.2011.11.024",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
Base.@kwdef struct DGLDDRK84_F{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    williamson_condition::Bool = true
end
# for backwards compatibility
function DGLDDRK84_F(stage_limiter!, step_limiter! = trivial_limiter!;
        williamson_condition = true)
    DGLDDRK84_F(stage_limiter!,
        step_limiter!,
        False(),
        williamson_condition)
end

@doc explicit_rk_docstring(
    "A fourth-order, six-stage low-storage method. Fixed timestep only.",
    "SHLDDRK64",
    references = "D. Stanescu, W. G. Habashi.
    2N-Storage Low Dissipation and Dispersion Runge-Kutta Schemes for Computational
    Acoustics.
    Journal of Computational Physics, 143(2), pp 674-681, 1998.
    doi: https://doi.org/10.1006/jcph.1998.5986
    }",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
Base.@kwdef struct SHLDDRK64{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    williamson_condition::Bool = true
end
# for backwards compatibility
function SHLDDRK64(stage_limiter!,
        step_limiter! = trivial_limiter!;
        williamson_condition = true)
    SHLDDRK64(stage_limiter!, step_limiter!, False(), williamson_condition)
end

@doc explicit_rk_docstring(
    "6-stage, fourth order low-stage, low-dissipation, low-dispersion scheme.
Fixed timestep only.", "RK46NL",
    references = "Julien Berland, Christophe Bogey, Christophe Bailly. Low-Dissipation and Low-Dispersion Fourth-Order Runge-Kutta Algorithm. Computers & Fluids, 35(10), pp 1459-1463, 2006. doi: https://doi.org/10.1016/j.compfluid.2005.04.003")
Base.@kwdef struct RK46NL{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function RK46NL(stage_limiter!, step_limiter! = trivial_limiter!)
    RK46NL(stage_limiter!, step_limiter!, False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
3-stage, second order (3S) low-storage scheme, optimized  the spectral difference method applied to wave propagation problems.",
    "ParsaniKetchesonDeconinck3S32",
    references = "Parsani, Matteo, David I. Ketcheson, and W. Deconinck.
    Optimized explicit Runge--Kutta schemes for the spectral difference method applied to wave propagation problems.
    SIAM Journal on Scientific Computing 35.2 (2013): A957-A986.
    doi: https://doi.org/10.1137/120885899")
Base.@kwdef struct ParsaniKetchesonDeconinck3S32{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function ParsaniKetchesonDeconinck3S32(stage_limiter!, step_limiter! = trivial_limiter!)
    ParsaniKetchesonDeconinck3S32{typeof(stage_limiter!), typeof(step_limiter!), False}(
        stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
8-stage, second order (3S) low-storage scheme, optimized for the spectral difference method applied to wave propagation problems.",
    "ParsaniKetchesonDeconinck3S82",
    references = "Parsani, Matteo, David I. Ketcheson, and W. Deconinck.
    Optimized explicit Runge--Kutta schemes for the spectral difference method applied to wave propagation problems.
    SIAM Journal on Scientific Computing 35.2 (2013): A957-A986.
    doi: https://doi.org/10.1137/120885899")
Base.@kwdef struct ParsaniKetchesonDeconinck3S82{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function ParsaniKetchesonDeconinck3S82(stage_limiter!, step_limiter! = trivial_limiter!)
    ParsaniKetchesonDeconinck3S82{typeof(stage_limiter!), typeof(step_limiter!), False}(
        stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
5-stage, third order (3S) low-storage scheme, optimized for the spectral difference method applied to wave propagation problems.",
    "ParsaniKetchesonDeconinck3S53",
    references = "Parsani, Matteo, David I. Ketcheson, and W. Deconinck.
    Optimized explicit Runge--Kutta schemes for the spectral difference method applied to wave propagation problems.
    SIAM Journal on Scientific Computing 35.2 (2013): A957-A986.
    doi: https://doi.org/10.1137/120885899")
Base.@kwdef struct ParsaniKetchesonDeconinck3S53{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function ParsaniKetchesonDeconinck3S53(stage_limiter!, step_limiter! = trivial_limiter!)
    ParsaniKetchesonDeconinck3S53{typeof(stage_limiter!), typeof(step_limiter!), False}(
        stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
17-stage, third order (3S) low-storage scheme, optimized for the spectral difference method applied to wave propagation problems.",
    "ParsaniKetchesonDeconinck3S173",
    references = "Parsani, Matteo, David I. Ketcheson, and W. Deconinck.
    Optimized explicit Runge--Kutta schemes for the spectral difference method applied to wave propagation problems.
    SIAM Journal on Scientific Computing 35.2 (2013): A957-A986.
    doi: https://doi.org/10.1137/120885899")
Base.@kwdef struct ParsaniKetchesonDeconinck3S173{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function ParsaniKetchesonDeconinck3S173(stage_limiter!, step_limiter! = trivial_limiter!)
    ParsaniKetchesonDeconinck3S173{typeof(stage_limiter!), typeof(step_limiter!), False}(
        stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
9-stage, fourth order (3S) low-storage scheme, optimized for the spectral difference method applied to wave propagation problems.",
    "ParsaniKetchesonDeconinck3S94",
    references = "Parsani, Matteo, David I. Ketcheson, and W. Deconinck.
    Optimized explicit Runge--Kutta schemes for the spectral difference method applied to wave propagation problems.
    SIAM Journal on Scientific Computing 35.2 (2013): A957-A986.
    doi: https://doi.org/10.1137/120885899")
Base.@kwdef struct ParsaniKetchesonDeconinck3S94{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function ParsaniKetchesonDeconinck3S94(stage_limiter!, step_limiter! = trivial_limiter!)
    ParsaniKetchesonDeconinck3S94{typeof(stage_limiter!), typeof(step_limiter!), False}(
        stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
18-stage, fourth order (3S) low-storage scheme, optimized for the spectral difference method applied to wave propagation problems.",
    "ParsaniKetchesonDeconinck3S184",
    references = "Parsani, Matteo, David I. Ketcheson, and W. Deconinck.
    Optimized explicit Runge--Kutta schemes for the spectral difference method applied to wave propagation problems.
    SIAM Journal on Scientific Computing 35.2 (2013): A957-A986.
    doi: https://doi.org/10.1137/120885899")
Base.@kwdef struct ParsaniKetchesonDeconinck3S184{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function ParsaniKetchesonDeconinck3S184(stage_limiter!, step_limiter! = trivial_limiter!)
    ParsaniKetchesonDeconinck3S184{typeof(stage_limiter!), typeof(step_limiter!), False}(
        stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
10-stage, fifth order (3S) low-storage scheme, optimized for the spectral difference method applied to wave propagation problems.",
    "ParsaniKetchesonDeconinck3S105",
    references = "Parsani, Matteo, David I. Ketcheson, and W. Deconinck.
    Optimized explicit Runge--Kutta schemes for the spectral difference method applied to wave propagation problems.
    SIAM Journal on Scientific Computing 35.2 (2013): A957-A986.
    doi: https://doi.org/10.1137/120885899")
Base.@kwdef struct ParsaniKetchesonDeconinck3S105{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function ParsaniKetchesonDeconinck3S105(stage_limiter!, step_limiter! = trivial_limiter!)
    ParsaniKetchesonDeconinck3S105{typeof(stage_limiter!), typeof(step_limiter!), False}(
        stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
20-stage, fifth order (3S) low-storage scheme, optimized for the spectral difference method applied to wave propagation problems.",
    "ParsaniKetchesonDeconinck3S205",
    references = "Parsani, Matteo, David I. Ketcheson, and W. Deconinck.
    Optimized explicit Runge--Kutta schemes for the spectral difference method applied to wave propagation problems.
    SIAM Journal on Scientific Computing 35.2 (2013): A957-A986.
    doi: https://doi.org/10.1137/120885899")
Base.@kwdef struct ParsaniKetchesonDeconinck3S205{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function ParsaniKetchesonDeconinck3S205(stage_limiter!, step_limiter! = trivial_limiter!)
    ParsaniKetchesonDeconinck3S205{typeof(stage_limiter!), typeof(step_limiter!), False}(
        stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
4-stage, third order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK43_2",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK43_2{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK43_2(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK43_2{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
5-stage, fourth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK54_3C",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK54_3C{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK54_3C(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK54_3C{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
9-stage, fifth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK95_4S",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK95_4S{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK95_4S(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK95_4S{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
9-stage, fifth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK95_4C",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK95_4C{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK95_4C(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK95_4C{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
9-stage, fifth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK95_4M",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK95_4M{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK95_4M(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK95_4M{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
5-stage, fourth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK54_3C_3R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK54_3C_3R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK54_3C_3R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK54_3C_3R{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
5-stage, fourth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK54_3M_3R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK54_3M_3R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK54_3M_3R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK54_3M_3R{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
5-stage, fourth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK54_3N_3R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK54_3N_3R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK54_3N_3R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK54_3N_3R{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
8-stage, fifth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK85_4C_3R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK85_4C_3R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK85_4C_3R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK85_4C_3R{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
8-stage, fifth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK85_4M_3R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK85_4M_3R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK85_4M_3R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK85_4M_3R{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
8-stage, fifth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK85_4P_3R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK85_4P_3R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK85_4P_3R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK85_4P_3R{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
5-stage, fourth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK54_3N_4R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK54_3N_4R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK54_3N_4R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK54_3N_4R{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
5-stage, fourth order low-storage scheme, optimized for compressible Navier–Stokes equations.
", "CKLLSRK54_3M_4R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK54_3M_4R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK54_3M_4R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK54_3M_4R{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "6-stage, fifth order low-storage scheme, optimized for compressible Navier–Stokes equations.",
    "CKLLSRK65_4M_4R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK65_4M_4R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK65_4M_4R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK65_4M_4R(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low-Storage Method
8-stage, fifth order low-storage scheme, optimized for compressible Navier–Stokes equations.",
    "CKLLSRK85_4FM_4R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK85_4FM_4R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK85_4FM_4R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK85_4FM_4R(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "CKLLSRK75_4M_5R: Low-Storage Method
7-stage, fifth order low-storage scheme, optimized for compressible Navier–Stokes equations.",
    "CKLLSRK75_4M_5R",
    references = """@article{kennedy2000low,
      title={Low-storage, explicit Runge--Kutta schemes for the compressible Navier--Stokes equations},
      author={Kennedy, Christopher A and Carpenter, Mark H and Lewis, R Michael},
      journal={Applied numerical mathematics},
      volume={35},
      number={3},
      pages={177--219},
      year={2000},
      publisher={Elsevier}}""")
Base.@kwdef struct CKLLSRK75_4M_5R{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function CKLLSRK75_4M_5R(stage_limiter!, step_limiter! = trivial_limiter!)
    CKLLSRK75_4M_5R{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "A third-order, five-stage method with embedded error estimator
designed for spectral element discretizations of compressible fluid mechanics.",
    "RDPK3Sp35",
    references = "Ranocha, Dalcin, Parsani, Ketcheson (2021)
    Optimized Runge-Kutta Methods with Automatic Step Size Control for
    Compressible Computational Fluid Dynamics
    [arXiv:2104.06836](https://arxiv.org/abs/2104.06836)")
Base.@kwdef struct RDPK3Sp35{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function RDPK3Sp35(stage_limiter!, step_limiter! = trivial_limiter!)
    RDPK3Sp35{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!, False())
end

@doc explicit_rk_docstring(
    "A third-order, five-stage method with embedded error estimator
using the FSAL property designed for spectral element discretizations of
compressible fluid mechanics.",
    "RDPK3SpFSAL35",
    references = "Ranocha, Dalcin, Parsani, Ketcheson (2021)
    Optimized Runge-Kutta Methods with Automatic Step Size Control for
    Compressible Computational Fluid Dynamics
    [arXiv:2104.06836](https://arxiv.org/abs/2104.06836)")
Base.@kwdef struct RDPK3SpFSAL35{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function RDPK3SpFSAL35(stage_limiter!, step_limiter! = trivial_limiter!)
    RDPK3SpFSAL35{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "A fourth-order, nine-stage method with embedded error estimator
designed for spectral element discretizations of compressible fluid mechanics.",
    "RDPK3Sp49",
    references = "Ranocha, Dalcin, Parsani, Ketcheson (2021)
    Optimized Runge-Kutta Methods with Automatic Step Size Control for
    Compressible Computational Fluid Dynamics
    [arXiv:2104.06836](https://arxiv.org/abs/2104.06836)")
Base.@kwdef struct RDPK3Sp49{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function RDPK3Sp49(stage_limiter!, step_limiter! = trivial_limiter!)
    RDPK3Sp49{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!, False())
end

@doc explicit_rk_docstring(
    "A fourth-order, nine-stage method with embedded error estimator
using the FSAL property designed for spectral element discretizations of
compressible fluid mechanics.",
    "RDPK3SpFSAL49",
    references = "Ranocha, Dalcin, Parsani, Ketcheson (2021)
    Optimized Runge-Kutta Methods with Automatic Step Size Control for
    Compressible Computational Fluid Dynamics
    [arXiv:2104.06836](https://arxiv.org/abs/2104.06836)")
Base.@kwdef struct RDPK3SpFSAL49{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function RDPK3SpFSAL49(stage_limiter!, step_limiter! = trivial_limiter!)
    RDPK3SpFSAL49{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "A fifth-order, ten-stage method with embedded error estimator
designed for spectral element discretizations of compressible fluid mechanics.",
    "RDPK3Sp510",
    references = "Ranocha, Dalcin, Parsani, Ketcheson (2021)
    Optimized Runge-Kutta Methods with Automatic Step Size Control for
    Compressible Computational Fluid Dynamics
    [arXiv:2104.06836](https://arxiv.org/abs/2104.06836)")
Base.@kwdef struct RDPK3Sp510{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function RDPK3Sp510(stage_limiter!, step_limiter! = trivial_limiter!)
    RDPK3Sp510{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!, False())
end

@doc explicit_rk_docstring(
    "A fifth-order, ten-stage method with embedded error estimator
using the FSAL property designed for spectral element discretizations of
compressible fluid mechanics.",
    "RDPK3SpFSAL510",
    references = "Ranocha, Dalcin, Parsani, Ketcheson (2021)
    Optimized Runge-Kutta Methods with Automatic Step Size Control for
    Compressible Computational Fluid Dynamics
    [arXiv:2104.06836](https://arxiv.org/abs/2104.06836)")
Base.@kwdef struct RDPK3SpFSAL510{StageLimiter, StepLimiter, Thread} <:
                   OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function RDPK3SpFSAL510(stage_limiter!, step_limiter! = trivial_limiter!)
    RDPK3SpFSAL510{typeof(stage_limiter!), typeof(step_limiter!), False}(stage_limiter!,
        step_limiter!,
        False())
end

#Low Storage Explicit Runge-Kutta Methods

@doc explicit_rk_docstring("Low-Storage Method
6-stage, fourth order low-stage, low-dissipation, low-dispersion scheme.
Fixed timestep only.", "HSLDDRK64",
    references = "D. Stanescu, W. G. Habashi.
    2N-Storage Low Dissipation and Dispersion Runge-Kutta Schemes for Computational
    Acoustics.
    Journal of Computational Physics, 143(2), pp 674-681, 1998.
    doi: https://doi.org/10.1006/jcph.1998.5986
    }",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
struct HSLDDRK64{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
    williamson_condition::Bool
    function HSLDDRK64(stage_limiter! = trivial_limiter!, step_limiter! = trivial_limiter!;
            williamson_condition = true, thread = False())
        Base.depwarn("HSLDDRK64 is deprecated, use SHLDDRK64 instead.", :HSLDDRK64)
        SHLDDRK64(; stage_limiter!, step_limiter!, thread, williamson_condition)
    end
end

@doc explicit_rk_docstring(
    "13-stage, fourth order low-storage method with optimized stability regions for
advection-dominated problems. Fixed timestep only.",
    "NDBLSRK134",
    references = "Jens Niegemann, Richard Diehl, Kurt Busch.
    Efficient Low-Storage Runge–Kutta Schemes with Optimized Stability Regions.
    Journal of Computational Physics, 231, pp 364-372, 2012.
    doi: https://doi.org/10.1016/j.jcp.2011.09.003",
    extra_keyword_description = """- `williamson_condition`: allows for an optimization that allows fusing broadcast expressions with the function call `f`. However, it only works for `Array` types.
                    """,
    extra_keyword_default = "williamson_condition = true")
Base.@kwdef struct NDBLSRK134{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
    williamson_condition::Bool = true
end
# for backwards compatibility
function NDBLSRK134(stage_limiter!, step_limiter! = trivial_limiter!;
        williamson_condition = true)
    NDBLSRK134(stage_limiter!,
        step_limiter!, False(),
        williamson_condition)
end

@doc explicit_rk_docstring(
    "Low dissipation and dispersion Runge-Kutta schemes for computational acoustics",
    "SHLDDRK_2N",
    references = "@article{stanescu19982n,
    title={2N-storage low dissipation and dispersion Runge-Kutta schemes for computational acoustics},
    author={Stanescu, D and Habashi, WG},
    journal={Journal of Computational Physics},
    volume={143},
    number={2},
    pages={674--681},
    year={1998},
    publisher={Elsevier}}")
Base.@kwdef struct SHLDDRK_2N{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SHLDDRK_2N(stage_limiter!, step_limiter! = trivial_limiter!)
    SHLDDRK_2N(stage_limiter!,
        step_limiter!,
        False())
end

@doc explicit_rk_docstring(
    "Low dissipation and dispersion Runge-Kutta schemes for computational acoustics",
    "SHLDDRK52",
    references = "@article{stanescu19982n,
    title={2N-storage low dissipation and dispersion Runge-Kutta schemes for computational acoustics},
    author={Stanescu, D and Habashi, WG},
    journal={Journal of Computational Physics},
    volume={143},
    number={2},
    pages={674--681},
    year={1998},
    publisher={Elsevier}}")
Base.@kwdef struct SHLDDRK52{StageLimiter, StepLimiter, Thread} <: OrdinaryDiffEqAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function SHLDDRK52(stage_limiter!, step_limiter! = trivial_limiter!)
    SHLDDRK52(stage_limiter!,
        step_limiter!,
        False())
end

using OrdinaryDiffEqLowStorageRK, DiffEqDevTools, Test, Random
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear, prob_ode_bigfloat2Dlinear

Random.seed!(100)

testTol = 0.25

f = (u, p, t) -> cos(t)
prob_ode_sin = ODEProblem(ODEFunction(f; analytic = (u0, p, t) -> sin(t)), 0.0, (0.0, 1.0))

f = (du, u, p, t) -> du[1] = cos(t)
prob_ode_sin_inplace = ODEProblem(ODEFunction(f; analytic = (u0, p, t) -> [sin(t)]), [0.0],
    (0.0, 1.0))

f = (u, p, t) -> sin(u)
prob_ode_nonlinear = ODEProblem(
    ODEFunction(f;
        analytic = (u0, p, t) -> 2 * acot(exp(-t) *
                                          cot(0.5))), 1.0,
    (0.0, 0.5))

f = (du, u, p, t) -> du[1] = sin(u[1])
prob_ode_nonlinear_inplace = ODEProblem(
    ODEFunction(f;
        analytic = (u0, p, t) -> [
            2 * acot(exp(-t) * cot(0.5))
        ]),
    [1.0], (0.0, 0.5))

test_problems_only_time = [prob_ode_sin, prob_ode_sin_inplace]
test_problems_linear = [prob_ode_linear, prob_ode_2Dlinear, prob_ode_bigfloat2Dlinear]
test_problems_nonlinear = [prob_ode_nonlinear, prob_ode_nonlinear_inplace]

# Test the memory usage, cf. #640
# Note: Basically, the size of the integrator should be the size of the cache
# plus the size of the initial condition (stored is integ.sol.prob.u0) if the
# keyword argument `alias_u0` is not set to `true` (default).
# Note: The memory requirements of the 2N methods can be reduced if an assignment
# of the form `tmp = A2end[i]*tmp + dt*f(u, p, t+c2end[i]*dt)` can be carried out
# without saving `f(u, p, t+c2end[i]*dt)` as `k`.
u0_large = rand(10^6)
prob_ode_large = ODEProblem((du, u, p, t) -> du .= u, u0_large, (0.0, 1.0))

println("SHLDDRK_2N")
dts_SHLDDRK_2N = (1 / 2) .^ (0:3)
alg = SHLDDRK_2N()
for prob in test_problems_only_time
    sim = test_convergence(dts_SHLDDRK_2N, prob, alg)
    @test sim.𝒪est[:final]≈4 atol=0.46
end
for prob in test_problems_linear
    sim = test_convergence(dts_SHLDDRK_2N, prob, alg)
    @test sim.𝒪est[:final]≈4 atol=0.46
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts_SHLDDRK_2N, prob, alg)
    @test sim.𝒪est[:final]≈4 atol=1
    # due to unusual saturation towards high dts(0.5 and onwards) and
    # saturation towards low dts due to less precision in the provided values of weights , tolerance is kept so high
end

println("SHLDDRK52")
dts = 1 .// 2 .^ (8:-1:4)
alg = SHLDDRK52()
for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
end
for prob in test_problems_linear
    sim = test_convergence(dts, prob, alg)
    @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
end
for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
end

@testset "ORK256" begin
    alg = ORK256()
    alg2 = ORK256(; williamson_condition = false)
    dts = 1 ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 2
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CarpenterKennedy2N54" begin
    alg = CarpenterKennedy2N54()
    alg2 = CarpenterKennedy2N54(; williamson_condition = false)
    dts = 1 ./ 2 .^ (7:-1:3)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 2
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "HSLDDRK64" begin
    # this method is deprecated
    alg = HSLDDRK64()
    @test alg isa SHLDDRK64
end

@testset "SHLDDRK64" begin
    alg = SHLDDRK64()
    alg2 = SHLDDRK64(; williamson_condition = true)
    dts = 1 ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 2
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "DGLDDRK73_C" begin
    alg = DGLDDRK73_C()
    alg2 = DGLDDRK73_C(; williamson_condition = false)
    dts = 1 ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 2
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "DGLDDRK84_C" begin
    alg = DGLDDRK84_C()
    alg2 = DGLDDRK84_C(; williamson_condition = false)
    dts = 1 ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 2
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "DGLDDRK84_F" begin
    alg = DGLDDRK84_F()
    alg2 = DGLDDRK84_F(; williamson_condition = false)
    dts = 1 ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 2
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "NDBLSRK124" begin
    alg = NDBLSRK124()
    alg2 = NDBLSRK124(; williamson_condition = false)
    dts = 1 ./ 2 .^ (7:-1:3)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 2
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "NDBLSRK134" begin
    alg = NDBLSRK134()
    alg2 = NDBLSRK134(; williamson_condition = false)
    dts = 1 ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 2
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "NDBLSRK144" begin
    alg = NDBLSRK144()
    alg2 = NDBLSRK144(; williamson_condition = false)
    dts = 1 ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
        sim = test_convergence(dts, prob, alg2)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 2
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg2, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CFRLDDRK64" begin
    alg = CFRLDDRK64()
    dts = 1 ./ 2 .^ (7:-1:4)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "TSLDDRK74" begin
    alg = TSLDDRK74()
    dts = 1 ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 3
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

# Methods from Carpenter, Kennedy, Lewis (2000)

function RemakeNew(p::ODEProblem)
    u1 = @. BigFloat(p.u0)
    tsp1 = @. BigFloat(p.tspan)
    remake(p; u0 = u1, tspan = tsp1)
end

test_problems_only_time_BigFloat = @. RemakeNew(test_problems_only_time)
test_problems_linear_BigFloat = @. RemakeNew(test_problems_linear)
f = (u, p, t) -> sin(u)
prob_nonlinear_A = ODEProblem(
    ODEFunction(f;
        analytic = (u0, p, t) -> 2 * acot(exp(-t) *
                                          cot(BigFloat(0.5)))),
    BigFloat(1.0), (BigFloat(0.0), BigFloat(0.5)))

f = (du, u, p, t) -> du[1] = sin(u[1])
prob_nonlinear_B = ODEProblem(
    ODEFunction(f;
        analytic = (u0, p, t) -> [
            2 * acot(exp(-t) * cot(BigFloat(0.5)))
        ]),
    [BigFloat(1.0)],
    (BigFloat(0.0), BigFloat(0.5)))
test_problems_nonlinear_BigFloat = [prob_nonlinear_A, prob_nonlinear_B]

@testset "CKLLSRK43_2" begin
    alg = CKLLSRK43_2()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol    # This scheme has linear order of 4
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 7
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK54_3C" begin
    alg = CKLLSRK54_3C()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈1 atol=testTol          # The CI plot is linear but the evaluated order is 1
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 7
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK95_4S" begin
    alg = CKLLSRK95_4S()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 7
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK95_4C" begin
    alg = CKLLSRK95_4C()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test_broken sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 7
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK95_4M" begin
    alg = CKLLSRK95_4M()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 7
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK54_3C_3R" begin
    alg = CKLLSRK54_3C_3R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 10
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK54_3M_3R" begin
    alg = CKLLSRK54_3M_3R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 0.5 atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 10
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK54_3N_3R" begin
    alg = CKLLSRK54_3N_3R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 10
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK85_4C_3R" begin
    alg = CKLLSRK85_4C_3R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 10
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK85_4M_3R" begin
    alg = CKLLSRK85_4M_3R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 10
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK85_4P_3R" begin
    alg = CKLLSRK85_4P_3R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 2 atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 10
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 9
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK54_3N_4R" begin
    alg = CKLLSRK54_3N_4R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 11
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 12
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 11
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK54_3M_4R" begin
    alg = CKLLSRK54_3M_4R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 0.5 atol=testTol                              # This scheme has linear orderof 4.5
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 11
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 12
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 11
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK65_4M_4R" begin
    alg = CKLLSRK65_4M_4R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 11
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 12
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 11
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK85_4FM_4R" begin
    alg = CKLLSRK85_4FM_4R()
    dts = BigFloat(1) ./ 2 .^ (10:-1:6)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 11
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 12
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 11
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "CKLLSRK75_4M_5R" begin
    alg = CKLLSRK75_4M_5R()
    dts = BigFloat(1) ./ 2 .^ (8:-1:4)
    for prob in test_problems_only_time_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear_BigFloat
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, adaptive = false, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 13
    integ = init(prob_ode_large, alg, adaptive = true, dt = 1.e-2, save_start = false,
        save_end = false, save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 14
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 13
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

# Methods from Parsani, Ketcheson, Deconinck (2013)

@testset "ParsaniKetchesonDeconinck3S32" begin
    alg = ParsaniKetchesonDeconinck3S32()
    dts = 1 ./ 2 .^ (7:-1:3)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        # higher order as pure quadrature
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "ParsaniKetchesonDeconinck3S82" begin
    alg = ParsaniKetchesonDeconinck3S82()
    dts = 1 ./ 2 .^ (8:-1:5)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        # higher order as pure quadrature
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "ParsaniKetchesonDeconinck3S53" begin
    alg = ParsaniKetchesonDeconinck3S53()
    dts = 1 ./ 2 .^ (7:-1:3)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        # higher order as pure quadrature
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "ParsaniKetchesonDeconinck3S173" begin
    alg = ParsaniKetchesonDeconinck3S173()
    dts = 1 ./ 2 .^ (7:-1:3)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        # higher order as pure quadrature
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    dts = 1 ./ 2 .^ (6:-1:3)
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=1
    end

    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "ParsaniKetchesonDeconinck3S94" begin
    alg = ParsaniKetchesonDeconinck3S94()
    dts = 1 ./ 2 .^ (7:-1:3)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "ParsaniKetchesonDeconinck3S184" begin
    alg = ParsaniKetchesonDeconinck3S184()
    dts = 1 ./ 2 .^ (6:-1:2)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    dts = 1 ./ 2 .^ (7:-1:2)
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "ParsaniKetchesonDeconinck3S105" begin
    alg = ParsaniKetchesonDeconinck3S105()
    dts = 1 ./ 1.95 .^ (5:-1:1)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    dts = 1 ./ 2 .^ (5:-1:2)
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    dts = 1.5 ./ 2 .^ (5:-1:2)
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "ParsaniKetchesonDeconinck3S205" begin
    alg = ParsaniKetchesonDeconinck3S205()
    dts = 1 ./ 1.95 .^ (5:-1:1)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    dts = 1 ./ 2 .^ (5:-1:2)
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=0.33
    end
    dts = 1.5 ./ 2 .^ (5:-1:2)
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 4
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

# Methods from Ranocha, Dalcin, Parsani, Ketcheson (2021)

@testset "RDPK3Sp35" begin
    alg = RDPK3Sp35()
    dts = 1 ./ 2 .^ (7:-1:3)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        # higher order as pure quadrature
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "RDPK3Sp49" begin
    alg = RDPK3Sp49()
    dts = 1 ./ 2 .^ (5:-1:2)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        # higher order as pure quadrature
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    dts = 1 ./ 2 .^ (8:-1:2)
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "RDPK3Sp510" begin
    alg = RDPK3Sp510()
    dts = 1 ./ 2 .^ (4.5:-1:1.5)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "RDPK3SpFSAL35" begin
    alg = RDPK3SpFSAL35()
    dts = 1 ./ 2 .^ (7:-1:3)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        # higher order as pure quadrature
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "RDPK3SpFSAL49" begin
    alg = RDPK3SpFSAL49()
    dts = 1 ./ 2 .^ (5:-1:2)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        # higher order as pure quadrature
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) + 1 atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    dts = 1 ./ 2 .^ (8:-1:2)
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "RDPK3SpFSAL510" begin
    alg = RDPK3SpFSAL510()
    dts = 1 ./ 2 .^ (4.5:-1:1.5)
    for prob in test_problems_only_time
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_linear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    for prob in test_problems_nonlinear
        sim = test_convergence(dts, prob, alg)
        @test sim.𝒪est[:final]≈OrdinaryDiffEqLowStorageRK.alg_order(alg) atol=testTol
    end
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false)
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 6
    integ = init(prob_ode_large, alg, dt = 1.e-2, save_start = false, save_end = false,
        save_everystep = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test Base.summarysize(integ) ÷ Base.summarysize(u0_large) <= 5
    # test whether aliasing u0 is bad
    new_prob_ode_nonlinear_inplace = ODEProblem(prob_ode_nonlinear_inplace.f, [1.0],
        (0.0, 0.5))
    sol_old = solve(prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false)
    sol_new = solve(
        new_prob_ode_nonlinear_inplace, alg, dt = 1.e-4, save_everystep = false,
        save_start = false, alias = ODEAliasSpecifier(alias_u0 = true))
    @test sol_old[end] ≈ sol_new[end]
end

@testset "VectorOfArray/StructArray compatibility" begin
    using RecursiveArrayTools, StaticArrays, StructArrays

    function rhs!(du_voa, u_voa, p, t)
        du = parent(du_voa)
        u = parent(u_voa)
        du .= u
    end

    # StructArray storage
    u = StructArray{SVector{1, Float64}}(ntuple(_ -> [1.0, 2.0], 1))
    ode = ODEProblem(rhs!, VectorOfArray(u), (0, 0.7))
    sol_SA = solve(ode, RDPK3SpFSAL35())

    # Vector{<:SVector} storage
    u = SVector{1, Float64}.([1.0, 2.0])
    ode = ODEProblem(rhs!, VectorOfArray(u), (0, 0.7))
    sol_SV = solve(ode, RDPK3SpFSAL35())

    @test sol_SA ≈ sol_SV
    @test sol_SV.stats.naccept == sol_SA.stats.naccept
    
    # Plain vector
    u = [1.0, 2.0]
    ode = ODEProblem(rhs!, u, (0, 0.7))
    sol = solve(ode, RDPK3SpFSAL35())
    @test sol.stats.naccept == sol_SA.stats.naccept
    @test sol.t ≈ sol_SA.t
    for i in eachindex(sol_SA.u), j in eachindex(u)
        @test sol.u[i][j] ≈ sol_SA.u[i][j][1]
    end
end

module OrdinaryDiffEqLowStorageRK

import OrdinaryDiffEqCore: alg_order, alg_adaptive_order, calculate_residuals!,
                           beta2_default, beta1_default, gamma_default,
                           initialize!, perform_step!, @unpack, unwrap_alg,
                           calculate_residuals, ssp_coefficient,
                           OrdinaryDiffEqAlgorithm, ispredictive,
                           OrdinaryDiffEqMutableCache, OrdinaryDiffEqConstantCache,
                           OrdinaryDiffEqAdaptiveAlgorithm, uses_uprev,
                           default_controller, PIDController,
                           alg_cache, _vec, _reshape, @cache, isfsal, full_cache,
                           constvalue, _unwrap_val,
                           trivial_limiter!, perform_step!, initialize!,
                           explicit_rk_docstring, get_fsalfirstlast
using FastBroadcast, Polyester, MuladdMacro, RecursiveArrayTools, Adapt
import StaticArrays: SArray, MVector, SVector, @SVector, StaticArray, MMatrix, SA
import Static: False
import RecursiveArrayTools: recursive_unitless_bottom_eltype
import OrdinaryDiffEqCore

using Reexport
@reexport using SciMLBase

include("arrayfuse.jl")
include("algorithms.jl")
include("alg_utils.jl")
include("low_storage_rk_caches.jl")
include("low_storage_rk_perform_step.jl")

import PrecompileTools
import Preferences
PrecompileTools.@compile_workload begin
    lorenz = OrdinaryDiffEqCore.lorenz
    lorenz_oop = OrdinaryDiffEqCore.lorenz_oop
    solver_list = []
    solver_list_nonadaptive = []
    prob_list = []

    low_storage = [
        RDPK3SpFSAL35(), RDPK3SpFSAL49()
    ]

    low_storage_nonadaptive = [
        CarpenterKennedy2N54(williamson_condition = false)
    ]

    if Preferences.@load_preference("PrecompileLowStorage", false)
        append!(solver_list, low_storage)
        append!(solver_list_nonadaptive, low_storage_nonadaptive)
    end

    if Preferences.@load_preference("PrecompileDefaultSpecialize", true)
        push!(prob_list, ODEProblem(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0)))
        push!(prob_list, ODEProblem(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0), Float64[]))
    end

    if Preferences.@load_preference("PrecompileAutoSpecialize", false)
        push!(prob_list,
            ODEProblem{true, SciMLBase.AutoSpecialize}(lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0)))
        push!(prob_list,
            ODEProblem{true, SciMLBase.AutoSpecialize}(lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0), Float64[]))
    end

    if Preferences.@load_preference("PrecompileFunctionWrapperSpecialize", false)
        push!(prob_list,
            ODEProblem{true, SciMLBase.FunctionWrapperSpecialize}(lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0)))
        push!(prob_list,
            ODEProblem{true, SciMLBase.FunctionWrapperSpecialize}(lorenz, [1.0; 0.0; 0.0],
                (0.0, 1.0), Float64[]))
    end

    if Preferences.@load_preference("PrecompileNoSpecialize", false)
        push!(prob_list,
            ODEProblem{true, SciMLBase.NoSpecialize}(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0)))
        push!(prob_list,
            ODEProblem{true, SciMLBase.NoSpecialize}(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0),
                Float64[]))
    end

    for prob in prob_list, solver in solver_list
        solve(prob, solver)(5.0)
    end

    for prob in prob_list, solver in solver_list_nonadaptive
        solve(prob, solver; dt = 0.5)(5.0)
    end

    prob_list = nothing
    solver_list = nothing
end

export ORK256, CarpenterKennedy2N54, SHLDDRK64, HSLDDRK64, DGLDDRK73_C, DGLDDRK84_C,
       DGLDDRK84_F, NDBLSRK124, NDBLSRK134, NDBLSRK144,
       CFRLDDRK64, TSLDDRK74, CKLLSRK43_2, CKLLSRK54_3C,
       CKLLSRK95_4S, CKLLSRK95_4C, CKLLSRK95_4M,
       CKLLSRK54_3C_3R, CKLLSRK54_3M_3R, CKLLSRK54_3N_3R, CKLLSRK85_4C_3R, CKLLSRK85_4M_3R,
       CKLLSRK85_4P_3R,
       CKLLSRK54_3N_4R, CKLLSRK54_3M_4R, CKLLSRK65_4M_4R, CKLLSRK85_4FM_4R, CKLLSRK75_4M_5R,
       ParsaniKetchesonDeconinck3S32, ParsaniKetchesonDeconinck3S82,
       ParsaniKetchesonDeconinck3S53, ParsaniKetchesonDeconinck3S173,
       ParsaniKetchesonDeconinck3S94, ParsaniKetchesonDeconinck3S184,
       ParsaniKetchesonDeconinck3S105, ParsaniKetchesonDeconinck3S205,
       RDPK3Sp35, RDPK3SpFSAL35, RDPK3Sp49, RDPK3SpFSAL49, RDPK3Sp510, RDPK3SpFSAL510,
       RK46NL, SHLDDRK_2N, SHLDDRK52
end

"""
    ArrayFuse{AT, T, P} <: AbstractArray{T, 1}

GPU Friendly type to wrap around two arrays - `visible` and `hidden`, for which when we `setindex!` some value `v` at index `i`
we get

```
visible[i] = p[1] * visible[i] + p[2] * v
hidden[i] = hidden[i] + p[3] * visible[i]
```

where p is a parameter tuple of size 3.
"""
struct ArrayFuse{AT, T, P}
    visible::AT
    hidden::AT
    p::P
end

Base.ndims(::Type{<:ArrayFuse{AT}}) where {AT} = ndims(AT)

function ArrayFuse(visible::AT, hidden::AT, p) where {AT}
    ArrayFuse{AT, eltype(visible), typeof(p)}(visible, hidden, p)
end

@inline function Base.copyto!(af::ArrayFuse, src::Broadcast.Broadcasted)
    @. af.visible = af.p[1] * af.visible + af.p[2] * src
    @. af.hidden = af.hidden + af.p[3] * af.visible
end

@inline function Base.materialize!(af::ArrayFuse, src::Broadcast.Broadcasted)
    copyto!(af, src)
end

# not recommended but good to have
@inline function Base.getindex(af::ArrayFuse, index::Int)
    return af.visible[index]
end

@inline function Base.setindex!(af::ArrayFuse, value, index::Int)
    af.visible[index] = af.p[1] * af.visible[index] + af.p[2] * value
    af.hidden[index] = muladd(af.p[3], af.visible[index], af.hidden[index])
end

@inline Base.size(af::ArrayFuse) = length(af.visible)
@inline Base.axes(af::ArrayFuse) = axes(af.visible)

function Adapt.adapt_structure(to, af::ArrayFuse{AT, T, P}) where {AT, T, P}
    ArrayFuse(adapt(to, af.visible), adapt(to, af.hidden), af.p)
end

alg_order(alg::ORK256) = 2
alg_order(alg::CarpenterKennedy2N54) = 4
alg_order(alg::NDBLSRK124) = 4
alg_order(alg::NDBLSRK134) = 4
alg_order(alg::NDBLSRK144) = 4
alg_order(alg::CFRLDDRK64) = 4
alg_order(alg::DGLDDRK73_C) = 3
alg_order(alg::TSLDDRK74) = 4
alg_order(alg::DGLDDRK84_C) = 4
alg_order(alg::DGLDDRK84_F) = 4
alg_order(alg::SHLDDRK64) = 4
alg_order(alg::RK46NL) = 4
alg_order(alg::ParsaniKetchesonDeconinck3S32) = 2
alg_order(alg::ParsaniKetchesonDeconinck3S82) = 2
alg_order(alg::ParsaniKetchesonDeconinck3S53) = 3
alg_order(alg::ParsaniKetchesonDeconinck3S173) = 3
alg_order(alg::ParsaniKetchesonDeconinck3S94) = 4
alg_order(alg::ParsaniKetchesonDeconinck3S184) = 4
alg_order(alg::ParsaniKetchesonDeconinck3S105) = 5
alg_order(alg::ParsaniKetchesonDeconinck3S205) = 5
alg_order(alg::CKLLSRK43_2) = 3
alg_order(alg::CKLLSRK54_3C) = 4
alg_order(alg::CKLLSRK95_4S) = 5
alg_order(alg::CKLLSRK95_4C) = 5
alg_order(alg::CKLLSRK95_4M) = 5
alg_order(alg::CKLLSRK54_3C_3R) = 4
alg_order(alg::CKLLSRK54_3M_3R) = 4
alg_order(alg::CKLLSRK54_3N_3R) = 4
alg_order(alg::CKLLSRK85_4C_3R) = 5
alg_order(alg::CKLLSRK85_4M_3R) = 5
alg_order(alg::RDPK3Sp35) = 3
alg_order(alg::RDPK3SpFSAL35) = 3
alg_order(alg::RDPK3Sp49) = 4
alg_order(alg::RDPK3SpFSAL49) = 4
alg_order(alg::RDPK3Sp510) = 5
alg_order(alg::RDPK3SpFSAL510) = 5
alg_order(alg::CKLLSRK85_4P_3R) = 5
alg_order(alg::CKLLSRK85_4FM_4R) = 5
alg_order(alg::CKLLSRK54_3N_4R) = 4
alg_order(alg::CKLLSRK75_4M_5R) = 5
alg_order(alg::CKLLSRK54_3M_4R) = 4
alg_order(alg::CKLLSRK65_4M_4R) = 5
alg_order(alg::SHLDDRK_2N) = 4
alg_order(alg::SHLDDRK52) = 2

isfsal(alg::ORK256) = false
isfsal(alg::CarpenterKennedy2N54) = false
isfsal(alg::DGLDDRK84_F) = false
isfsal(alg::DGLDDRK73_C) = false
isfsal(alg::DGLDDRK84_C) = false
isfsal(alg::RDPK3Sp35) = false
isfsal(alg::RDPK3Sp49) = false
isfsal(alg::RDPK3Sp510) = false
isfsal(alg::SHLDDRK64) = false
isfsal(alg::NDBLSRK134) = false
isfsal(alg::NDBLSRK124) = false
isfsal(alg::NDBLSRK144) = false

uses_uprev(alg::ORK256, adaptive::Bool) = false
uses_uprev(alg::SHLDDRK64, adaptive::Bool) = false
uses_uprev(alg::CarpenterKennedy2N54, adaptive::Bool) = false
uses_uprev(alg::NDBLSRK124, adaptive::Bool) = false
uses_uprev(alg::NDBLSRK134, adaptive::Bool) = false
uses_uprev(alg::DGLDDRK84_F, adaptive::Bool) = false
uses_uprev(alg::NDBLSRK144, adaptive::Bool) = false
uses_uprev(alg::DGLDDRK84_C, adaptive::Bool) = false
uses_uprev(alg::TSLDDRK74, adaptive::Bool) = false
uses_uprev(alg::CFRLDDRK64, adaptive::Bool) = false
uses_uprev(alg::DGLDDRK73_C, adaptive::Bool) = false
uses_uprev(alg::CKLLSRK43_2, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK54_3C, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK95_4S, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK95_4C, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK95_4M, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK54_3C_3R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK54_3M_3R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK54_3N_3R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK85_4C_3R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK85_4M_3R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK85_4P_3R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK54_3N_4R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK54_3M_4R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK65_4M_4R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK85_4FM_4R, adaptive::Bool) = adaptive
uses_uprev(alg::CKLLSRK75_4M_5R, adaptive::Bool) = adaptive

function default_controller(alg::RDPK3Sp35, cache, qoldinit, args...)
    QT = typeof(qoldinit)
    return PIDController(map(Base.Fix1(convert, QT), (0.64, -0.31, 0.04))...)
end

function default_controller(alg::RDPK3SpFSAL35, cache, qoldinit, args...)
    QT = typeof(qoldinit)
    return PIDController(map(Base.Fix1(convert, QT), (0.70, -0.23, 0.00))...)
end

function default_controller(alg::RDPK3Sp49, cache, qoldinit, args...)
    QT = typeof(qoldinit)
    return PIDController(map(Base.Fix1(convert, QT), (0.25, -0.12, 0.00))...)
end

function default_controller(alg::RDPK3SpFSAL49, cache, qoldinit, args...)
    QT = typeof(qoldinit)
    return PIDController(map(Base.Fix1(convert, QT), (0.38, -0.18, 0.01))...)
end

function default_controller(alg::RDPK3Sp510, cache, qoldinit, args...)
    QT = typeof(qoldinit)
    return PIDController(map(Base.Fix1(convert, QT), (0.47, -0.20, 0.06))...)
end

function default_controller(alg::RDPK3SpFSAL510, cache, qoldinit, args...)
    QT = typeof(qoldinit)
    return PIDController(map(Base.Fix1(convert, QT), (0.45, -0.13, 0.00))...)
end
